﻿Imports SciLors_GrooveDownloader.MainWindow
Imports System.Xml
Imports System.IO

Public Module Skin
    Public CurrentSkin As UIElement

    Public tabMain As TabControl
    Public tabSearchLoad As TabItem
    Public tabExtFunctions As TabItem
    Public tabSettings As TabItem

    'Basic
    Public mniFile As MenuItem
    Public mniCheckForUpdates As MenuItem
    Public mniAvailableSoftware As MenuItem
    Public mniSciLorsWebsite As MenuItem
    Public mniExit As MenuItem

    Public mniExtra As MenuItem
    Public mniReconnect As MenuItem
    Public mniClearDownloadList As MenuItem
    Public mniGoToDownloadDir As MenuItem

    Public mniHelp As MenuItem
    Public mniCommandLine As MenuItem
    Public mniDebugMode As MenuItem
    Public mniSupport As MenuItem

    Public mniLanguage As MenuItem

    Public mniFacebook As MenuItem
    Public mniDonate As MenuItem

    Public txtSearch As TextBox
    Public btnSearch As Button
    Public btnPopularSongs As Button

    Public btnSelectAll As Button
    Public btnDeselectAll As Button
    Public btnInvertSelection As Button
    Public btnAddToDownloadList As Button
    Public txtResultFilter As TextBox
    Public dagSearch As DataGrid

    Public pgbDownloadState As ProgressBar
    Public btnDownload As Button
    Public dagDownload As DataGrid

    Public txtDebug As TextBox

    'ExtFunctions
    Public tabExFuncBatch As TabItem
    Public tabExFuncPlaylists As TabItem

    Public grpBatchSearch As GroupBox
    Public txtBatchSearch As TextBox
    Public btnBatchSearch As Button
    Public btnImportBatch As Button

    Public grpLogin As GroupBox
    Public txtBatchDescription As TextBlock
    Public txtLoginName As TextBox
    Public lblLoginName As Label
    Public txtLoginPass As PasswordBox
    Public lblLoginPass As Label
    Public grpPlaylists As GroupBox
    Public btnLoginFetchPlaylists As Button
    Public grpPlaylistById As GroupBox
    Public txtPlaylistId As TextBox
    Public btnFetchPlaylistById As Button
    Public cmbFetchPlaylists As ComboBox
    Public btnFetchPlaylists As Button

    'Settings
    Public tabConfigList As TabControl
    Public tabConfigDownload As TabItem
    Public tabConfigVarious As TabItem

    Public grpBaseDir As GroupBox
    Public txtBaseDir As TextBox
    Public btnBaseDir As Button

    Public grpPattern As GroupBox
    Public cmbPattern As ComboBox
    Public lblPatternPreview As Label
    Public lblPatternInfo As Label

    Public grpExistingFileHandling As GroupBox
    Public rbtExistingSkip As RadioButton
    Public rbtExistingOverwrite As RadioButton
    Public rbtExistingAutoRename As RadioButton

    Public grpVarious As GroupBox
    Public chkUncheckSearchResults As CheckBox
    Public chkAutoCheckUpdates As CheckBox
    'Public grpConfigConnection As GroupBox
    Public grpProxy As GroupBox
    Public tabConfigConnection As TabItem
    Public lblProxy As Label
    Public txtProxy As TextBox
    Public lblProxyUser As Label
    Public txtProxyUser As TextBox
    Public lblProxyPass As Label
    Public txtProxyPass As PasswordBox
    Public btnProxyTest As Button
    Public btnSave As Button

    Private xml As XmlDocument

    Public Sub loadLanguageXml(ByVal filename As String)
        Try
            xml = New XmlDocument()
            xml.Load(filename)
            If Not xml.FirstChild.Name = "SciLor" Then
                xml = Nothing
            End If
        Catch
            xml = Nothing
        End Try
    End Sub

    Public Sub SetControlVariables()
        Try
            tabMain = getElementByName(Of TabControl)("tabMain")

            SetBasicView()
            SetExtFunctionView()
            SetSettingsView()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub SetBasicView()
        tabSearchLoad = getElementByName(Of TabItem)("tabSearchLoad")
        tabExtFunctions = getElementByName(Of TabItem)("tabExtFunctions")
        tabSettings = getElementByName(Of TabItem)("tabSettings")

        mniFile = getElementByName(Of MenuItem)("mniFile")
        mniCheckForUpdates = getElementByName(Of MenuItem)("mniCheckForUpdates")
        mniAvailableSoftware = getElementByName(Of MenuItem)("mniAvailableSoftware")
        mniSciLorsWebsite = getElementByName(Of MenuItem)("mniSciLorsWebsite")
        mniExit = getElementByName(Of MenuItem)("mniExit")

        mniExtra = getElementByName(Of MenuItem)("mniExtra")
        mniReconnect = getElementByName(Of MenuItem)("mniReconnect")
        mniClearDownloadList = getElementByName(Of MenuItem)("mniClearDownloadList")
        mniGoToDownloadDir = getElementByName(Of MenuItem)("mniGoToDownloadDir")

        mniLanguage = getElementByName(Of MenuItem)("mniLanguage")

        mniHelp = getElementByName(Of MenuItem)("mniHelp")
        mniCommandLine = getElementByName(Of MenuItem)("mniCommandLine")
        mniDebugMode = getElementByName(Of MenuItem)("mniDebugMode")
        mniSupport = getElementByName(Of MenuItem)("mniSupport")

        mniDonate = getElementByName(Of MenuItem)("mniDonate")
        mniFacebook = getElementByName(Of MenuItem)("mniFacebook")


        txtSearch = getElementByName(Of TextBox)("txtSearch")
        btnSearch = getElementByName(Of Button)("btnSearch")
        btnPopularSongs = getElementByName(Of Button)("btnPopularSongs")

        btnSelectAll = getElementByName(Of Button)("btnSelectAll")
        btnDeselectAll = getElementByName(Of Button)("btnDeselectAll")
        btnInvertSelection = getElementByName(Of Button)("btnInvertSelection")
        btnAddToDownloadList = getElementByName(Of Button)("btnAddToDownloadList")
        txtResultFilter = getElementByName(Of TextBox)("txtResultFilter")
        dagSearch = getElementByName(Of DataGrid)("dagSearch")

        pgbDownloadState = getElementByName(Of ProgressBar)("pgbDownloadState")
        btnDownload = getElementByName(Of Button)("btnDownload")
        dagDownload = getElementByName(Of DataGrid)("dagDownload")

        txtDebug = getElementByName(Of TextBox)("txtDebug")
    End Sub

    Private Sub SetExtFunctionView()
        tabExFuncBatch = getElementByName(Of TabItem)("tabExFuncBatch")
        tabExFuncPlaylists = getElementByName(Of TabItem)("tabExFuncPlaylists")

        grpBatchSearch = getElementByName(Of GroupBox)("grpBatchSearch")
        txtBatchDescription = getElementByName(Of TextBlock)("txtBatchDescription")
        txtBatchSearch = getElementByName(Of TextBox)("txtBatchSearch")
        btnBatchSearch = getElementByName(Of Button)("btnBatchSearch")
        btnImportBatch = getElementByName(Of Button)("btnImportBatch")

        grpLogin = getElementByName(Of GroupBox)("grpLogin")
        txtLoginName = getElementByName(Of TextBox)("txtLoginName")
        lblLoginName = getElementByName(Of Label)("lblLoginName")
        txtLoginPass = getElementByName(Of PasswordBox)("txtLoginPass")
        lblLoginPass = getElementByName(Of Label)("lblLoginPass")
        btnLoginFetchPlaylists = getElementByName(Of Button)("btnLoginFetchPlaylists")

        grpPlaylists = getElementByName(Of GroupBox)("grpPlaylists")
        cmbFetchPlaylists = getElementByName(Of ComboBox)("cmbFetchPlaylists")
        btnFetchPlaylists = getElementByName(Of Button)("btnFetchPlaylists")

        grpPlaylistById = getElementByName(Of GroupBox)("grpPlaylistById")
        txtPlaylistId = getElementByName(Of TextBox)("txtPlaylistId")
        btnFetchPlaylistById = getElementByName(Of Button)("btnFetchPlaylistById")
    End Sub

    Private Sub SetSettingsView()
        tabConfigList = getElementByName(Of TabControl)("tabConfigList")
        tabConfigDownload = getElementByName(Of TabItem)("tabConfigDownload")
        tabConfigVarious = getElementByName(Of TabItem)("tabConfigVarious")

        grpBaseDir = getElementByName(Of GroupBox)("grpBaseDir")
        txtBaseDir = getElementByName(Of TextBox)("txtBaseDir")
        btnBaseDir = getElementByName(Of Button)("btnBaseDir")

        grpPattern = getElementByName(Of GroupBox)("grpPattern")
        cmbPattern = getElementByName(Of ComboBox)("cmbPattern")
        lblPatternPreview = getElementByName(Of Label)("lblPatternPreview")
        lblPatternInfo = getElementByName(Of Label)("lblPatternInfo")

        grpExistingFileHandling = getElementByName(Of GroupBox)("grpExistingFileHandling")
        rbtExistingSkip = getElementByName(Of RadioButton)("rbtExistingSkip")
        rbtExistingOverwrite = getElementByName(Of RadioButton)("rbtExistingOverwrite")
        rbtExistingAutoRename = getElementByName(Of RadioButton)("rbtExistingAutoRename")

        grpVarious = getElementByName(Of GroupBox)("grpVarious")
        chkUncheckSearchResults = getElementByName(Of CheckBox)("chkUncheckSearchResults")
        chkAutoCheckUpdates = getElementByName(Of CheckBox)("chkAutoCheckUpdates")
        'grpConfigConnection = getElementByName(Of GroupBox)("grpConfigConnection")
        grpProxy = getElementByName(Of GroupBox)("grpProxy")
        tabConfigConnection = getElementByName(Of TabItem)("tabConfigConnection")
        lblProxy = getElementByName(Of Label)("lblProxy")
        txtProxy = getElementByName(Of TextBox)("txtProxy")
        lblProxyUser = getElementByName(Of Label)("lblProxyUser")
        txtProxyUser = getElementByName(Of TextBox)("txtProxyUser")
        lblProxyPass = getElementByName(Of Label)("lblProxyPass")
        txtProxyPass = getElementByName(Of PasswordBox)("txtProxyPass")
        btnProxyTest = getElementByName(Of Button)("btnProxyTest")

        btnSave = getElementByName(Of Button)("btnSave")
    End Sub

    Public Function getElementByName(Of T As DependencyObject)(ByVal name As String) As T
        Dim obj As DependencyObject = LogicalTreeHelper.FindLogicalNode(DirectCast(CurrentSkin, DependencyObject), name)
        Try
            If obj Is Nothing Then Throw New Exception()
            Return TryCast(LanguageFix(obj, name), T)
        Catch ex As Exception
            MsgBox("Error: " + "Skin Problem, check " + name + " " + ex.Message)
            Return Nothing
        End Try
    End Function

    Private Function LanguageFix(ByVal element As DependencyObject, ByVal name As String) As DependencyObject
        If element Is Nothing Then
            'Throw New Exception("Skin problem")
        End If

        Dim elementContent As String = getLanguageText(name, "")
        If Not elementContent = "" Then
            If TypeOf element Is Button Then
                Dim lang As Button = TryCast(element, Button)
                getLanguageText(name, lang.Content)
                lang.Content = elementContent
                Return lang
            ElseIf TypeOf element Is TabItem Then
                Dim lang As TabItem = TryCast(element, TabItem)
                getLanguageText(name, lang.Header)
                lang.Header = elementContent
                Return lang
            ElseIf TypeOf element Is MenuItem Then
                Dim lang As MenuItem = TryCast(element, MenuItem)
                getLanguageText(name, lang.Header)
                lang.Header = elementContent
                Return lang
            ElseIf TypeOf element Is GroupBox Then
                Dim lang As GroupBox = TryCast(element, GroupBox)
                getLanguageText(name, lang.Header)
                lang.Header = elementContent
                Return lang
            ElseIf TypeOf element Is TextBlock Then
                Dim lang As TextBlock = TryCast(element, TextBlock)
                getLanguageText(name, lang.Text)
                lang.Text = elementContent
                Return lang
            ElseIf TypeOf element Is Label Then
                Dim lang As Label = TryCast(element, Label)
                getLanguageText(name, lang.Content)
                lang.Content = elementContent
                Return lang
            ElseIf TypeOf element Is RadioButton Then
                Dim lang As RadioButton = TryCast(element, RadioButton)
                getLanguageText(name, lang.Content)
                lang.Content = elementContent
                Return lang
            ElseIf TypeOf element Is CheckBox Then
                Dim lang As CheckBox = TryCast(element, CheckBox)
                getLanguageText(name, lang.Content)
                lang.Content = elementContent
                Return lang
            End If
        End If
        Return element
    End Function

    Public Function getLanguageText(ByVal name As String, ByVal alternative As String) As String
        If xml IsNot Nothing Then
            If Not alternative = "" Then CreateLangPres(name, alternative)
            Try
                Dim node As XmlElement = xml.GetElementsByTagName(name)(0)
                Dim data As String = node.GetAttribute("string")
                Return data
            Catch ex As Exception
                'MessageBox.Show(ex.Message)
            End Try
        End If
        Return alternative
    End Function

    Public Sub CreateLangPres(ByVal name As String, ByVal data As String)
        Dim filename As String = GetAppPathSpecial("", "langCreate.xml")
        Dim myXml As New XmlDocument
        Dim node As XmlElement = myXml.CreateElement(name)
        node.SetAttribute("string", data)

        If File.Exists(filename) Then
            myXml.Load(filename)
            Dim nodes As XmlNodeList = myXml.GetElementsByTagName(name)

            If nodes.Count = 0 Then
                myXml.FirstChild.AppendChild(node)
            Else
                myXml.FirstChild.ReplaceChild(node, nodes(0))
            End If
        Else
            myXml.LoadXml("<SciLor english=""English"" name=""English"" icon=""english.gif""></SciLor>")
            myXml.FirstChild.AppendChild(node)
        End If



        'myXml.Save(filename)
    End Sub
End Module